main/urls.py
from django.conf import settings
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('schemas/', include('schemas.urls', namespace='schemas'))
]

# if settings.DEBUG:
urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)
urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

schemas/urls.py
from django.urls import path

from schemas.views import CreateSchemaView, ListSchemaView, EditSchemaView

app_name = 'schemas'
urlpatterns = [
    path('new', CreateSchemaView.as_view(), name='new'),
    path('list', ListSchemaView.as_view(), name='list'),
    path('edit/<int:pk>', EditSchemaView.as_view(), name='edit'),
]

common/models.py
from django.db import models


class TimestampAbstractModel(models.Model):
    created_at = models.DateTimeField(auto_now_add=True)
    updated_at = models.DateTimeField(auto_now=True)

    class Meta:
        abstract = True

schemas/models.py
from django.contrib.auth import get_user_model
from django.utils.translation import gettext_lazy as _
from django.db import models

from common.models import TimestampAbstractModel

COMMA_CHOICE = ','
COLUMN_SEPARATOR_CHOICES = (
    (COMMA_CHOICE, _('Comma')),
)

DOUBLE_QUOTE_CHOICE = "\""
STRING_CHARACTER_CHOICES = (
    (DOUBLE_QUOTE_CHOICE, _('Double-quote')),
)


class Schema(TimestampAbstractModel):
    user = models.ForeignKey(
        get_user_model(),
        related_name='schemas',
        on_delete=models.CASCADE,
        # TODO Remove it. Use user from request
        null=True,
        blank=True,
    )
    title = models.CharField(
        verbose_name=_('Title'),
        max_length=255,
    )
    column_separator = models.CharField(
        verbose_name=_('Column separator'),
        max_length=255,
        default=COMMA_CHOICE,
        choices=COLUMN_SEPARATOR_CHOICES,
    )
    string_character = models.CharField(
        verbose_name=_('String character'),
        max_length=255,
        default=DOUBLE_QUOTE_CHOICE,
        choices=STRING_CHARACTER_CHOICES,
    )

    class Meta:
        verbose_name = _('Schema')
        verbose_name_plural = _('Schemas')


FULL_NAME_TYPE = 'full name'
JOB_TYPE = 'job'
EMAIL_TYPE = 'email'
DOMAIN_TYPE = 'domain name'
PHONE_NUMBER_TYPE = 'phone number'
INTEGER_TYPE = 'integer'
# Company name
# Text (with specified range for a number of sentences)
# Integer (with specified range)
# Address
# Date
COLUMN_TYPE_CHOICES = (
    (FULL_NAME_TYPE, _('Full name')),
    (JOB_TYPE, _('Job')),
    (EMAIL_TYPE, _('Email')),
    (DOMAIN_TYPE, _('Domain')),
    (PHONE_NUMBER_TYPE, _('Phone number')),
    (INTEGER_TYPE, _('Integer')),
)


class Column(models.Model):
    schema = models.ForeignKey(
        Schema,
        related_name='columns',
        on_delete=models.CASCADE,
    )
    name = models.CharField(
        verbose_name=_('Column name'),
        max_length=255,
    )
    type = models.CharField(
        verbose_name=_('Column type'),
        max_length=255,
        choices=COLUMN_TYPE_CHOICES,
        default=FULL_NAME_TYPE,
    )
    from_value = models.IntegerField(
        null=True,
        blank=True,
    )
    to_value = models.IntegerField(
        null=True,
        blank=True,
    )
    order = models.IntegerField(default=0)

    class Meta:
        verbose_name = _('Column')
        verbose_name_plural = _('Columns')

schemas/forms.py
from crispy_forms.helper import FormHelper
from crispy_forms.layout import Layout, Div, Field, Fieldset, HTML, ButtonHolder, Submit
from django import forms
from django.forms import inlineformset_factory

from schemas.custom_layout_object import Formset
from schemas.models import Schema, Column


class ColumnForm(forms.ModelForm):
    class Meta:
        model = Column
        exclude = ()


class SchemaForm(forms.ModelForm):
    class Meta:
        model = Schema
        exclude = (
            'user',
            'created_at',
            'updated_at,',
        )

    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)
        self.helper = FormHelper()
        self.helper.form_tag = True
        self.helper.form_class = 'form-horizontal'
        self.helper.label_class = 'col-md-3 create-label'
        self.helper.field_class = 'col-md-9'
        self.helper.layout = Layout(
            Div(
                Field('title'),
                Field('column_separator'),
                Field('string_character'),
                Fieldset(
                    'Schemas columns',
                    Formset('columns')
                ),
                HTML("<br>"),
                ButtonHolder(Submit('submit', 'Save')),
            )
        )


ColumnFormSet = inlineformset_factory(
    Schema,
    Column,
    form=ColumnForm,
    fields=('name', 'type', 'from_value', 'to_value', 'order'),
    extra=1,
    can_delete=True,
)

schemas/views.py
from django.db import transaction
from django.urls import reverse_lazy
from django.views.generic import CreateView, ListView, UpdateView

from schemas.forms import ColumnFormSet, SchemaForm
from schemas.models import Schema


class CreateSchemaView(CreateView):
    form_class = SchemaForm
    model = Schema
    success_url = reverse_lazy('schemas:list')
    template_name = 'create.html'

    def get_context_data(self, **kwargs):
        data = super().get_context_data(**kwargs)
        if self.request.POST:
            data['columns'] = ColumnFormSet(self.request.POST)
        else:
            data['columns'] = ColumnFormSet()
        return data

    def form_valid(self, form):
        context = self.get_context_data()
        columns = context['columns']
        with transaction.atomic():
            # form.instance.user = self.request.user
            self.object = form.save()
            if columns.is_valid():
                columns.instance = self.object
                columns.save()
        return super().form_valid(form)

    def get_success_url(self):
        return self.success_url


class EditSchemaView(UpdateView):
    model = Schema
    form_class = SchemaForm
    template_name = 'edit.html'
    success_url = reverse_lazy('schemas:list')

    def get_context_data(self, **kwargs):
        data = super().get_context_data(**kwargs)
        if self.request.POST:
            data['columns'] = ColumnFormSet(self.request.POST, instance=self.object)
        else:
            data['columns'] = ColumnFormSet(instance=self.object)
        return data

    def form_valid(self, form):
        context = self.get_context_data()
        columns = context['columns']
        with transaction.atomic():
            # form.instance.user = self.request.user
            self.object = form.save()
            if columns.is_valid():
                columns.instance = self.object
                columns.save()
        return super().form_valid(form)

    def get_success_url(self):
        return self.success_url


class ListSchemaView(ListView):
    queryset = Schema.objects.all().order_by('-updated_at')
    template_name = 'list.html'

schemas/templates/create.html
{% extends "base.html" %}
{% load crispy_forms_tags %}

{% block content %}
    <div class="container">
        <div class="card">
            <div class="card-header">
                Create collection
            </div>
            <div class="card-body">
                {% crispy form %}
            </div>
        </div>
    </div>
{% endblock %}

schemas/templates/edit.html
{% extends "base.html" %}
{% load crispy_forms_tags %}

{% block content %}
    <div class="container">
        <div class="card">
            <div class="card-header">
                Create collection
            </div>
            <div class="card-body">
                {% crispy form %}
            </div>
        </div>
    </div>
{% endblock %}

schemas/templates/list.html
{% extends "base.html" %}
{% load crispy_forms_tags %}

{% block content %}
    <a href="{% url 'schemas:new' %}" class="btn btn-success">New schema</a>
    <table class="table mt-2">
        <thead>
        <tr>
            <th>#</th>
            <th>Title</th>
            <th>Updated at</th>
            <th>Actions</th>
        </tr>
        </thead>
        <tbody>
        {% for obj in object_list %}
            <tr>
                <td>{{ obj.id }}</td>
                <td><a href="{% url 'schemas:edit' pk=obj.id %}">{{ obj.title }}</a></td>
                <td>{{ obj.updated_at }}</td>
                <td>Pusto</td>
            </tr>
        {% endfor %}
        </tbody>
    </table>
{% endblock %}

templates/base.html
<!doctype html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css"
          integrity="sha384-Vkoo8x4CGsO3+Hhxv8T/Q5PaXtkKtu6ug5TOeNV6gBiFeWPGFN9MuhOf23Q9Ifjh" crossorigin="anonymous">
    <title>Django People</title>
</head>
<header>
    <div class="container">
        <div class="row py-2">
            <ul class="list-group list-group-horizontal-md">
                <li class="list-group-item">Fake CSV</li>
                <li class="list-group-item"><a href="{% url 'schemas:list' %}">Schemas</a></li>
                <li class="list-group-item">Morbi leo risus</li>
            </ul>
        </div>
    </div>
</header>
<body>
<div class="container">
    <div class="row justify-content-center">
        <div class="col-9">
            <h1 class="mt-2">Django CSV</h1>
            <hr class="mt-0 mb-4">
            {% block content %}
            {% endblock %}
        </div>
    </div>
</div>
</body>
</html>

templates/formset.html
{% load crispy_forms_tags %}
{% load static %}
<table>
{{ formset.management_form|crispy }}

    {% for form in formset.forms %}
            <tr class="{% cycle 'row1' 'row2' %} formset_row-{{ formset.prefix }}">
                {% for field in form.visible_fields %}
                <td>
                    {# Include the hidden fields in the form #}
                    {% if forloop.first %}
                        {% for hidden in form.hidden_fields %}
                            {{ hidden }}
                        {% endfor %}
                    {% endif %}
                    {{ field.errors.as_ul }}
                    {{ field|as_crispy_field }}
                </td>
                {% endfor %}
            </tr>
    {% endfor %}

</table>
<br>
<script src="//ajax.googleapis.com/ajax/libs/jquery/2.1.3/jquery.min.js">
</script>
<script src="{% static 'js/jquery.formset.js' %}">
</script>
<script type="text/javascript">
    $('.formset_row-{{ formset.prefix }}').formset({
        addText: 'Add column',
        deleteText: 'Delete',
        prefix: '{{ formset.prefix }}',
    });
</script>